import java.util.Random;

public class ChessBot extends Player {
    
    Board board;

    public ChessBot(ChessColor color){
        super(color);
        board = null;
    }

    public void setBoard(Board board){
        this.board = board;
    }

    @Override
    public FromTo getFromTo() {
        Random rd = new Random();
        FromTo chosenMove = new FromTo(0,0,0,0);
        int max = -1;
        int scorePiece;
        
        for(Move move : getAllMoves(board)) { 
            if(move.pieceAtDestination == null) {
                scorePiece = 0;
            } else {
                scorePiece = move.pieceAtDestination.getValue();
            }

            if(this.isCheck && move.pieceAtOrigin.getType() == Piece.Type.KING)
                scorePiece += 100;
                
            if (scorePiece > max || (scorePiece == max && rd.nextBoolean())) {
                chosenMove = new FromTo(move.origin.getX(),move.origin.getY(),move.destination.getX(),move.destination.getY());
                max = scorePiece;
            }
        }
        
        return chosenMove;
    }
}
