# Projet de jeu d'échec en Java

Projet Final (S3 Programmation 2)

## Binôme

Alexandre AGUEDO

Astrid BEYER


Aix Marseille Université

L2 Informatique

Groupe 3

## Encadrant de TPs et projet

Pacôme PERROTIN

## Objectif et tâches

L’objectif de ce projet est de programmer un jeu d’´echec. Ce jeu permet `a deux joueurs humains de jouer ensemble
ou bien à un joueur humain de jouer contre une version très simple d’un joueur artificiel, ou à deux joueurs artificiels
de jouer ensemble !

En savoir plus : http://pageperso.lif.univ-mrs.fr/~alexis.nasr/Ens/PROG2/projet_echecs_an.pdf

## Les fichiers

* boardConfigurationFiles/
> Dossier contenant des placements de pièces pré-remplis, ces placements sont utiles pour tester le programme dans diverses situations.

* img/
> Dossier avec les images en format PNG des 12 pièces de l'échiquier (6 noires et 6 blanches).

* Player.java
> Classe abstraite déterminant un joueur. 

* Board.java
> Classe permettant d'instancier le plateau de jeu d'échec.

* ChessBot.java
> Classe qui étend Player. ChessBot est la classe d'un joueur robot qui va choisir les coups les plus avantageux (rapportant le plus de score) lorsqu'il jouera.

* Human.java
> Classe qui étend Player. Cette classe permet à un utilisateur de jouer. 

* ChessColor.java
> Énumération des couleurs possibles des joueurs/pièces.

* Piece.java
> Classe abstraite déterminant une pièce de l'échiquier.

* Bishop.java ; King.java ; Knight.java ; Pawn.java ; Queen.java ; Rook.java
> Respectivement les classes du fou, roi, cavalier, pion, dame et tour. Ces classes étendent toutes la classe Piece et déterminent, pour chaque pièce, leurs mouvements possibles et autorisés.

* TestChess.java
> Fichier de tests.

* Move.java
> Classe publique qui permet à une pièce de se déplacer d'un point à un autre dans l'échiquier.

* ChessUI.java
> Classe gérant l'interface du jeu d'échec et la possibilité de déplacer ses pièces avec sa souris.

* GameUI.java
> Classe gérant le déroulement de la partie.

* Coordinates.java
> Classe permettant de récupérer des coordonnées.

* FromTo.java
> Classe permettant de récupérer les coordonnées d'origine d'une pièce et les coordonnées de destination d'une pièce.

* Main.java
> Classe principale qui lance le jeu.