import java.util.ArrayList;
import java.util.List;

/**
 * A group of students.
 */

public class Cohort {
  private final String name;
  private final List<Student> students;

  /**
   * Constructs a cohort with a name equals to the specified {@code name} and no students.
   * @param name the name of the constructed Cohort
   */

  public Cohort(String name) {
    this.name = name;
    this.students = new ArrayList<>();
  }

  /**
   * Add the specified {@code student} to the students of the cohort.
   * @param student the student to be added to the cohort
   */
  public void addStudent(Student student){
	  students.add(student);
  }

  /**
   * Returns the list of students of the cohort.
   * @return the list of students of the cohort.
   */
  public List<Student> getStudents(){
	  return students;
  }

  /**
   * Print via the standard output the name of the cohort and all results associated to the students with their average
   * grade.
   */
  public void printStudentsResults(){
	  System.out.println(name);
	  for (Student Student : students){
		  Student.printResults();
	  }
		  
	  
  }

  private void printName(){
	  System.out.println(name);
  }

  /**
   * Returns the name of the cohort.
   * @return the name of the cohort
   */
  @Override
  public String toString() {
	  return name;
  }
  
  
  public int numberOfStudentsThatValidated(){
	  int i = 0;
	  for (Student Student : students){
		  Grade averageGrade = Student.getAverageGrade();
		  if (averageGrade.getValue() >= 10)
			  i += 1;
	  }
		  
	  return i;
  }
  
  
  public int numberOfAbsent(){
	  int i = 0;
	  for (Student Student : students){
		  Grade averageGrade = Student.getAverageGrade();
		  if (averageGrade.isAbsent())
			  i += 1;
	  }
	 return i;
  }
  
  public double noteMax(){
	  double noteMax = 0;
	  for (Student Student : students){
		  Grade grade = Student.getAverageGrade();
		  if (grade.getValue() > noteMax)
			  noteMax = grade.getValue();	  
	  }
	  return noteMax;
  }
  
  
  public double noteMin(){
	  double noteMin = 20;
	  for (Student Student : students){
		  Grade grade = Student.getAverageGrade();
		  if (grade.getValue() < noteMin)
			  noteMin = grade.getValue();	  
	  }
	  return noteMin;
  }
  
  
  public Grade AverageCohort() {
	  double i = 0;
	  double sum = 0;
	  for (Student Student : students){
		  if(Student.getAverageGrade().isAbsent())
			  sum =+ 0;
		  else
			  	sum += Student.getAverageGrade().getValue();
		  		i += 1;  
	  }
	  return new Grade(sum/i);
  }
}
