import java.util.Scanner;
import java.io.*;

/**
 * Class Crossword : Creates a 2D array of characters read from the input file
 */

public class Crossword
{
   private char array[][]; 	// Tableaux 2D contenant les caractères
   private int rows;      	// Nombres de lignes de array 
   private int columns;		// Nombres de colonnes de array
   private int WordCount;   // Nombre d'occurences d'un mot
   private int PositionX;	// Colonne de début du mot
   private int PositionY;	// Ligne de début du mot
   private int EndX;		// Colonne de fin du mot 
   private int EndY;		// Ligne de fin du mot 
   
      
   /*** Constructor: Reads each line from File <file> and writes to a new row in the array. 
    ** Updates <rows> and <columns> to height and width of the array. */
   public Crossword(File file) throws IOException {

	   // Code pour calculer la taille du tableau et initialiser les variables d'instance "rows" et "columns"
	   
	   Scanner input = new Scanner(file);
	   columns = input.next().length();
	   while (input.hasNextLine()) {
		   rows++;
		   input.nextLine();
	   }
	   
	   
	   // Code pour créer le tableau "array"
	   
	   char[][] array = new char[rows][columns];
	   
	   
	   // Code pour remplir "array" avec les caractères du Fichier "file" 
	   
	   Scanner scanner = new Scanner(file);
	   for (int i = 0; i < rows; i++) {
		   String fileLine = scanner.nextLine();
		   for ( int j = 0; j < columns; j++) {
			   char nextChar = fileLine.charAt(j);
			   array[i][j] = nextChar;
 		   }
		   this.array = array;
	   }
	   
	   
	   }

   
   /*** Methode Search(String) : Trouver le premier occurence du mot <word> dans le Tableau 
    *** Si touver, mettre à jour les valeurs (PositionY, PositionX, EndY, EndX)*/
   
   public boolean search(String word) {
	   WordCount = 0;
	   // Verifier que le taile du mot "word" est supérieure à zero. Sinon rien à faire.
	   if (word.length()> 0) {
		   
	   
	   
	   // Chercher le premier caractère du mot "word" dans le tableau array.
	   char firstchar = word.charAt(0);
	   for (int r = 0; r < rows; ++r) {
		   for (int c = 0; c < columns; ++c) {
			   
			if (firstchar == array[r][c]) {
				   PositionX = c;
				   PositionY = r;
		   		
	   
	    // Si array[i][j] contient ce caractère, alors le mot peut apparaître dans le même ligne,
	   	// ou dans le même colonne. Utiliser les methodes SearchRow() ou searchColumn() selon le cas.
		  
		   if (searchRow(PositionX, PositionY, word)) {
			   System.out.println("Word found in the row");
			   displayWord();
			   WordCount += 1;
			   
			   }
	   		 if (searchColumn(PositionX, PositionY, word)) {
	   				displayWord();
	   				System.out.println("Word found in the column");
	   				WordCount += 1;

	   		 }

			}

		   }
	   }

	   }
	   				return (WordCount != 0);// mot pas trouvé
   
	   
	   }
   
   
   /* Methode Interne SearchRow(int,int, String) : Cherche une ligne du tableaux pour le mot <word> à partir de array[y][x] */
   
   private boolean searchRow(int x, int y, String word) {
	   int wordlength = word.length();
	   int i = 0;
	   String wordfound = "";
	   
	   
	   
	   for (  int chary = 0; chary < wordlength; chary++ ) {
		   if (word.charAt(i) == array[PositionX][chary + y]) {
			   i += 1;
			   
			   wordfound = wordfound + array[PositionX][chary + y];	   
		   }
		   else return false;
		   	
	   }
	   if (wordfound.equals(word)){
		   EndY = wordlength -1 + y;
		   EndX = PositionX;
		   }
	   	
	   		
		  return wordfound.equals(word); 
   }
   
   /* Methode Interne SearchRow(int,int, String) : Cherche une colonne du tableaux pour le mot <word> à partir de array[y][x] */
   
   private boolean searchColumn(int x, int y, String word) {

	   int wordlength = word.length();
	   int i = 0;
	   String wordfound = "";
	    
	   for (  int charx = 0; charx < wordlength; charx++ ) {
		   if (word.charAt(i) == array[charx + x][PositionY]) {
			   i += 1;
			   
			   wordfound = wordfound + array[charx + x][PositionY];
			   
		   }
		   else return false;
		   	
	   }
	   if (wordfound.equals(word)){
		   EndX = wordlength -1 + x;
		   EndY = PositionY;
		   }
	   	
	   
		   
	   return wordfound.equals(word); }
   

   /*** Methode pour visualiser le tableau. (Déjà fourni) */
   public void display() {
	   if (rows>0 && columns>0)
		   CrosswordGUI.display(array);  
	   else 
		   System.out.println("Error: Array is Empty.");
   }

   /*** Methode pour visualiser le tableau avec le mot en surbrillance. (Déjà fourni) */
   public void displayWord() {
		if ((PositionX<0) || (PositionX>EndX) || (EndX>=columns)) {
			System.out.println("Error: Incorrect x-coordinates for Word");
			return;
		}
		if ((PositionY<0) || (PositionY>EndY) || (EndY>=rows)) {
			System.out.println("Error: Incorrect y-coordinates for Word");
			return;		
		}
		CrosswordGUI.display(array, PositionY, PositionX, EndY, EndX);  
   }
   
   
   
   public int countWord(String word) {
	   return WordCount;
	   }
	   
   
}

