/**
 * Interface pour representer un image en version noir et blanc.
 */

public interface GrayImage extends Image {
    void setPixel(GrayColor gray, int x, int y);
    GrayColor getPixelGrayColor(int x, int y);
    GrayColor getDominantGray(int squareX, int squareY, int squareSize);
    default int dominantGray(int squareX, int squareY, int squareSize) {
        int sumOfGrayLevels = 0;
        
        for (int x = squareX; x < squareX+squareSize; ++x)
            for (int y = squareY; y < squareY+squareSize; ++y)
                sumOfGrayLevels += getPixelGrayColor(x, y).getGrayLevel();
        
        return (sumOfGrayLevels / (squareSize*squareSize));
    }
}
