public class Pixelate implements Transform {
    int newPixelSize;
    int newSquareY;
    int newSquareX;
    GrayColor dominantColor;
    
    Pixelate(int newPixelSize){
    	
        this.newPixelSize = newPixelSize;
    }

    @Override
    public void applyTo(GrayImage image) {
        for (int x = 0; x < (image.getWidth()) / newPixelSize; ++x) {
            for (int y = 0; y < (image.getHeight()) / newPixelSize; ++y) {
                newSquareY = y * newPixelSize;
                newSquareX = x * newPixelSize;
                dominantColor = image.getDominantGray(newSquareX, newSquareY, newPixelSize);
                for (int squareX = 0; squareX < newPixelSize; ++squareX){
                    for (int squareY = 0; squareY < newPixelSize; ++squareY ){
                    	int Y = newSquareY + squareY;
                    	int X = newSquareX + squareX;
                        
                        image.setPixel(dominantColor, X, Y);
                    }
                }

            }
        }
    }
}
