import java.util.Objects;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Arrays;
import java.util.ListIterator;

public class MyArrayList<T> implements List<T> {
	private int capacity;
	private int size;
	private transient T[] elementData;
	
	
	 public MyArrayList(int initialCapacity) {
			
		        if (initialCapacity < 0)
		            throw new IllegalArgumentException("Illegal Capacity: "+
		                                               initialCapacity);
			this.elementData = (T[])new Object[initialCapacity];
			}

	 public MyArrayList() {
			this(10);
			}
	 
    @Override
    public boolean add(T element) {
    	ensureCapacity(1);
        elementData[this.size] = element;
        this.size += 1;
        return true;
    }

    @Override
    public int size() {
        return this.size;
    }


    @Override
    public boolean isEmpty() {
        return this.size == 0;
    }


    @Override
    public T get(int index) {
        Objects.checkIndex(index, this.size);
    	return elementData[index];
	
    }


    @Override
    public Iterator<T> iterator() {
    	return listIterator();    }
    
    
    @Override
    public T remove(int index) {
	T lou = get(index);
    for (int i = index + 1; i < size; i++)
    	elementData[i-1] = elementData[i];
    size--;
    return lou;

    }

    
    @Override
    public boolean contains(Object o) {
    	for (T el : elementData)
            if (o.equals(el)) {
                return true;
            }
        return false;

	
    }

    public String toString() {
    	StringBuffer sb = new StringBuffer(0);
    	for (T s : elementData) {
    		if (s != null)
            {            
            sb.append(s);
            sb.append(" ");
            }
         }
         String str = sb.toString();
         return str;
    }
    
    @Override
    public boolean equals(Object obj) {
    if (this == obj) {
    return true;
    }
    if (!(obj instanceof List<?>)) {
    return false;
    }
    List<?> other = (List<?>) obj;
    // TODO: check whether this and other are equal.
    return this.equals(other);
    }
    
    @Override
    public Object[] toArray() {
	return null;
    }

    @Override
    public boolean remove(Object o) {
        remove(indexOf(o));
        return true;

    }

    @Override
    public boolean addAll(Collection collection) {
        return false;
    }

    @Override
    public boolean addAll(int i, Collection collection) {
        return false;
    }

    @Override
    public void clear() {

    }

    @SuppressWarnings("unchecked")
	@Override
    public Object set(int i, Object o) {
    	Objects.checkIndex(i, size());
        T lib = get(i);
        elementData[i] = (T)o;
        return lib;

    }

    @SuppressWarnings("unchecked")
	@Override
    public void add(int i, Object o) {
    	ensureCapacity(1);
        add((T)o);
        for (int index = size() - 1; index > i; i++){
            T lib = get(index);
            set(index, get(index-1));
            set(index-1, lib);
        }

    }

    @Override
    public int indexOf(Object o) {
        for (int i = 0; i < size(); i++)
            if (o.equals(get(i))){
                return i;
            }
        return size;
    }

    @Override
    public int lastIndexOf(Object o) {
        for (int i = size() - 1; i >= 0; i--)
            if (o.equals(get(i))){
                return i;
            }
        return -1;
    }


    @Override
    public ListIterator listIterator() {
    	return listIterator(0);
    }

    @Override
    public ListIterator<T> listIterator(int i) {
        MyArrayList<T> myArrayList = this;
        return new ListIterator<T>() {
            int ind = i - 1;

            @Override
            public boolean hasNext() {
                return ind + 1 < size();
            }

            @Override
            public T next() {
                return get(++ind);
            }

            @Override
            public boolean hasPrevious() {
                return ind > 0;
            }

            @Override
            public T previous() {
                return get(--ind);
            }

            @Override
            public int nextIndex() {
                return ind + 1;
            }

            @Override
            public int previousIndex() {
                return ind - 1;
            }

            @Override
            public void remove() {
                myArrayList.remove(ind--);
            }

            public void set(T obj) {
                myArrayList.set(ind, obj);
            }

            public void add(T obj) {
                myArrayList.add(ind, obj);
            }
        };
    }

    

    @Override
    public List subList(int i, int i1) {
        return null;
    }

    @Override
    public boolean retainAll(Collection collection) {
        return false;
    }

    @Override
    public boolean removeAll(Collection collection) {
        return false;
    }

    @Override
    public boolean containsAll(Collection collection) {
        return false;
    }

    @Override
    public Object[] toArray(Object[] objects) {
        return new Object[0];
    }
    
    public void ensureCapacity(int Cap){
        if (size + Cap <= capacity) return;
        int newCapacity = 1;
        while (newCapacity < size + Cap) {
        	newCapacity *= 2;
        	}
        if (newCapacity == capacity) return;
        T[] newelementData = (T[])new Object[newCapacity];
        for (int i = 0; i < size(); ++i){
            newelementData[i] = get(i);
        }
        elementData = newelementData;
        capacity = newCapacity;
    }

}
