import tp2.lib.Painter;
import static tp2.lib.Tools.sleep;
import java.awt.*;
import java.util.Random;

/**
 * Created by Arnaud Labourel on 15/10/2018.
 */
public class Triangle implements Shape {
    private final Point[] vertices;

    public Triangle(Point p1, Point p2, Point p3) {
        vertices = new Point[]{p1, p2, p3};
    }

    private Triangle(Point[] vertices){
        this.vertices = vertices;
    }
    
    
    public static void test_triangle(Painter painter){
        Point p1 = new Point(100,100);
        Point p2 = new Point(200,100);
        Point p3 = new Point(200,200);

        Point point[] = {p1,p2,p3};

        Random random= new Random();
        Shape r = new Triangle(point);
        System.out.println(r.getArea());
        for(int i =30; i<400; i+=30) {
            Shape t2 = r.translate(i, i);
            sleep(100);
            t2.draw(painter, new Color(random.nextFloat(),
                    random.nextFloat(), random.nextFloat()));
        }
    }


    @Override
    public double getPerimeter() {
        return (vertices[0].distance(vertices[1]) +
               vertices[1].distance(vertices[2]) +
                vertices[2].distance(vertices[0]));
    }

    @Override
    public void draw(Painter painter, Color color) {
        for (int i = 0; i < 3; i++) {
            vertices[i].drawLine(vertices[ (i+1) % 3],painter,color);
        }
    }

    @Override
    public Shape translate(int dx, int dy) {
        return new Triangle(
                vertices[0].translate(dx,dy),
                vertices[1].translate(dx,dy),
                vertices[2].translate(dx,dy)
                );
    }

    @Override
    public double getArea() {
        double p = getPerimeter()/2;
        double a = vertices[0].distance(vertices[1]);
        double b = vertices[1].distance(vertices[2]);
        double c = vertices[2].distance(vertices[0]);
        return Math.sqrt( p * (p-a) * (p-b) * (p-c) );
    }


}
