import java.awt.Color;
import static tp2.lib.Tools.sleep;
import tp2.lib.Painter;

public class Turtle {
Color penColor;
double angleDirection;
Point position;
boolean penIsDown;
Painter painter;

public Turtle(int width, int height) {
	penColor = null;
	angleDirection = 270;
	painter = new Painter(width, height);
	penIsDown = false;
	position = new Point(width/2, height/2);
	
}

public void moveForward(double distance) {
	sleep(500);
	double move = -(Math.sqrt(distance)-position.x);
	Point newPosition = position.translate(position.x + move, position.y );
	newPosition = newPosition.rotate(angleDirection);
	
	if (penIsDown){
		position.drawLine(newPosition, painter, penColor);
	}
	
	
	position = newPosition;
}

public void setColor(Color color) {
	penColor = color;
}

public void turnLeft(double angle) {
	 angleDirection = angleDirection - angle;
	 while (angleDirection < 0) {
		 angleDirection = 360 - angleDirection;
		 
	 }
}

public void turnRight(double angle) {
	angleDirection = angleDirection + angle;
	 while (angleDirection > 360) {
		 angleDirection = angleDirection - 360;
	 }
}

public void setPenDown() {
	penIsDown = true;

}

public void setPenUp() {
	penIsDown = false;

}




}
